//   ƼŬ 𵨸ϱ  Į   .
// 
#include "cv.h" 
#include "highgui.h" 

#define CVX_YELLOW  CV_RGB(255, 255, 0)
#define CVX_WHITE   CV_RGB(255, 255, 255)
#define CVX_RED     CV_RGB(255, 0, 0)

#define phi2xy(mat)	\
	cvPoint( cvRound(img->width/2 + img->width/3*cos(mat->data.fl[0])), \
	cvRound( img->height/2 - img->width/3*sin(mat->data.fl[0])) ) 

int main(int argc, char** argv) 
{
	// ʱȭ. Į  ü, ,  ߻ .
	// 
	cvNamedWindow( "Kalman", 1 ); 

	CvRandState rng; 
	cvRandInit( &rng, 0, 1, -1, CV_RAND_UNI );

	IplImage* img = cvCreateImage( cvSize(500, 500), 8, 3 ); 
	CvKalman* kalman = cvCreateKalman( 2, 1, 0 ); 

	//  ʹ (phi, delta_phi) ̴. , ġ ӵ̴. 
	//  ̿Ͽ ʱȭѴ. 
	//
	CvMat* x_k = cvCreateMat( 2, 1, CV_32FC1 );
	cvRandSetRange( &rng, 0, 0.1, 0 );
	rng.disttype = CV_RAND_NORMAL;
	cvRand( &rng, x_k );

	// μ 
	//
	CvMat* w_k = cvCreateMat( 2, 1, CV_32FC1 );

	//  ʹ  ϳ̴. 
	//
	CvMat* z_k = cvCreateMat( 1, 1, CV_32FC1 );
	cvZero( z_k );

	//   'F' k ð ܰ迡 ¿ k+1 ð ܰ  
	// 踦 Ѵ. ̰   '' Ÿ. 
	//
	const float F[] = { 1, 1, 0, 1 };
	memcpy( kalman->transition_matrix->data.fl, F, sizeof(F) ); 

	// ٸ Į  Ķ ʱȭ
	//
	cvSetIdentity( kalman->measurement_matrix,    cvRealScalar(1) );
	cvSetIdentity( kalman->process_noise_cov,     cvRealScalar(1e-5) );
	cvSetIdentity( kalman->measurement_noise_cov, cvRealScalar(1e-1) );
	cvSetIdentity( kalman->error_cov_post,        cvRealScalar(1));

	// ʱ ¸ Ƿ Ѵ. 
	// 
	cvRand( &rng, kalman->state_post );

	while( 1 ) 
	{ 
		//  ġ  
		const CvMat* y_k = cvKalmanPredict( kalman, 0 );

		// ġ  (z_k) 
		// 
		cvRandSetRange(
			&rng, 
			0, 
			sqrt(kalman->measurement_noise_cov->data.fl[0]), 
			0
		); 
		cvRand( &rng, z_k ); 
		cvMatMulAdd( kalman->measurement_matrix, x_k, z_k, z_k ); 

		//  ׸. 
		// 
		cvZero( img ); 
		cvCircle( img, phi2xy(z_k), 4, CVX_YELLOW );	// ġ
		cvCircle( img, phi2xy(y_k), 4, CVX_WHITE, 2 );	// "" 
		cvCircle( img, phi2xy(x_k), 4, CVX_RED );		//  
		cvShowImage( "Kalman", img ); 

		// Į    
		// 
		cvKalmanCorrect( kalman, z_k );

		//   'F' . (,  ܰ )
		// ׸ μ  w_k . 
		// 
		cvRandSetRange(
			&rng, 
			0, 
			sqrt(kalman->process_noise_cov->data.fl[0]), 
			0
		); 
		cvRand( &rng, w_k ); 
		cvMatMulAdd( kalman->transition_matrix, x_k, w_k, x_k );

		// ESCŰ  
		if( cvWaitKey( 100 ) == 27 ) break; 
	}

	cvDestroyWindow( "Kalman" );
	cvReleaseImage( &img );
	cvReleaseKalman( &kalman );
	cvReleaseMat( &x_k );
	cvReleaseMat( &w_k );
	cvReleaseMat( &z_k );

	return 0; 
} 
