// ø Ī. 
// : ex7-5 <image> <template>
// 

#include <cv.h> 
#include <cxcore.h> 
#include <highgui.h> 
#include <stdio.h> 

int main( int argc, char** argv ) 
{
	IplImage *src, *templ, *ftmp[6]; // ftmp:    
	int i; 

	if( argc == 3)
	{
		// Է  ҷ
		if( (src = cvLoadImage(argv[1], 1)) == 0 ) { 
			printf("Error on reading src image %s\n", argv[1]); 
			return (-1);
		}

		// ø  ҷ
		if( (templ=cvLoadImage(argv[2], 1)) == 0) {
			printf("Error on reading template %s\n", argv[2]);
			return (-1); 
		} 

		//   
		int iwidth = src->width - templ->width + 1; 
		int iheight = src->height - templ->height + 1; 

		for( i = 0 ; i < 6 ; ++i )
			ftmp[i] = cvCreateImage(cvSize(iwidth,iheight), 32, 1); 
	
		// ø Ī 
		for( i = 0 ; i < 6 ; ++i )
		{ 
			cvMatchTemplate( src, templ, ftmp[i], i); 
			cvNormalize(ftmp[i], ftmp[i], 1, 0, CV_MINMAX);
		} 

		// ȭ 
		cvNamedWindow("Template", 0); 		cvShowImage("Template", templ); 
		cvNamedWindow("Image", 0); 			cvShowImage("Image", src); 
		cvNamedWindow("SQDIFF", 0);			cvShowImage("SQDIFF", ftmp[0]); 
		cvNamedWindow("SQDIFF_NORMED", 0);	cvShowImage("SQDIFF_NORMED", ftmp[1]); 
		cvNamedWindow("CCORR", 0);			cvShowImage("CCORR", ftmp[2]); 
		cvNamedWindow("CCORR_NORMED", 0); 	cvShowImage("CCORR_NORMED", ftmp[3]); 
		cvNamedWindow("CCOEFF", 0); 		cvShowImage("CCOEFF", ftmp[4]); 
		cvNamedWindow("CCOEFF_NORMED", 0); 	cvShowImage("CCOEFF_NORMED", ftmp[5]); 

		cvWaitKey(0);

		// ޸ 
		cvReleaseImage(&src); cvReleaseImage(&templ); 
		for( i = 0 ; i < 6 ; ++i ) cvReleaseImage(&ftmp[i]);
		cvDestroyAllWindows();
	} 
	else 
	{ 
		printf("Usage: %s <image> <template>\n", argv[0]);
	} 

	return 0;
} 
