// FaceDetectDlg.cpp :  
//

#include "stdafx.h"
#include "FaceDetect.h"
#include "FaceDetectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//  α׷  Ǵ CAboutDlg ȭ Դϴ.

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

// Դϴ.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFaceDetectDlg ȭ 




CFaceDetectDlg::CFaceDetectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFaceDetectDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pImage = NULL;
	m_pCascade = NULL;
}

CFaceDetectDlg::~CFaceDetectDlg()
{
	if( m_pImage ) cvReleaseImage( &m_pImage );
	if( m_pCascade ) cvReleaseHaarClassifierCascade( &m_pCascade );
}

void CFaceDetectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CFaceDetectDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_LOAD, &CFaceDetectDlg::OnBnClickedLoad)
END_MESSAGE_MAP()


// CFaceDetectDlg ޽ ó

BOOL CFaceDetectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ý ޴ "..." ޴ ׸ ߰մϴ.

	// IDM_ABOUTBOX ý   ־ մϴ.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// ϸ з ҷ
	m_pCascade = (CvHaarClassifierCascade*)cvLoad( "haarcascade_frontalface_alt2.xml", 0, 0, 0 );
	if( m_pCascade == NULL )
	{
		AfxMessageBox("haarcascade_frontalface_alt2.xml  ε  ϴ.");
		PostMessage(WM_CLOSE);
		return FALSE;
	}

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

void CFaceDetectDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CFaceDetectDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		if( m_pImage != NULL )
		{
			//  ϱ
			CWnd* pWnd = GetDlgItem(IDC_DISPLAY);	//   ޾ƿ
			CClientDC dc(pWnd);						//  DC 

			RECT rect;
			pWnd->GetClientRect(&rect);				//  ũ ޾ƿ

			CvvImage image;
			image.CopyOf(m_pImage, 1);
			image.DrawToHDC(dc.m_hDC, &rect);		//  ũ⿡ °  
		}
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CFaceDetectDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CFaceDetectDlg::OnBnClickedLoad()
{
	char szFilter[] = "Image Files (*.bmp; *.jpg; *.png; *.tif)|*.bmp; *.jpg; *. png; *.tif|All Files (*.*)|*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, AfxGetMainWnd());
	if( dlg.DoModal() == IDOK )
	{
		if( m_pImage ) cvReleaseImage( &m_pImage );
		m_pImage = cvLoadImage(dlg.GetPathName(), CV_LOAD_IMAGE_COLOR);
		double scale = 1.3;

		CvMemStorage* storage = cvCreateMemStorage(0); 

		//  غ 
		// 
		IplImage* gray = cvCreateImage( cvSize(m_pImage->width,m_pImage->height), 8, 1 ); 
		IplImage* small_img = cvCreateImage(
			cvSize( cvRound(m_pImage->width/scale), cvRound(m_pImage->height/scale)), 8, 1 
			); 
		cvCvtColor( m_pImage, gray, CV_BGR2GRAY ); 
		cvResize( gray, small_img, CV_INTER_LINEAR ); 
		cvEqualizeHist( small_img, small_img );

		// ü  
		// 
		cvClearMemStorage( storage ); 
		CvSeq* objects = cvHaarDetectObjects(
			small_img, 
			m_pCascade, 
			storage,
			1.1, 
			2, 
			0 	/*CV_HAAR_DO_CANNY_PRUNING*/, 
			cvSize(30, 30)
			);

		// ü ã ڽ ׸.
		// 
		for( int i = 0 ; i < (objects ? objects->total : 0) ; i++ ) 
		{
			CvRect* r = (CvRect*)cvGetSeqElem( objects, i );
			CvPoint center;
			int radius;
			center.x = cvRound((r->x + r->width*0.5)*scale);
			center.y = cvRound((r->y + r->height*0.5)*scale);
			radius = cvRound((r->width + r->height)*0.25*scale);
			cvCircle( m_pImage, center, radius, cvScalar(255, 0, 0), 3, 8, 0 );
		} 

		cvReleaseImage( &gray ); 
		cvReleaseImage( &small_img ); 
		cvReleaseMemStorage( &storage );

		Invalidate(FALSE);
	}
}
