#include <stdio.h> 
#include <cv.h> 
#include <highgui.h> 

void sum_rgb( IplImage* src, IplImage* dst ) 
{
	//   ä   . 
	IplImage* r = cvCreateImage( cvGetSize(src), IPL_DEPTH_8U, 1 ); 
	IplImage* g = cvCreateImage( cvGetSize(src), IPL_DEPTH_8U, 1 ); 
	IplImage* b = cvCreateImage( cvGetSize(src), IPL_DEPTH_8U, 1 );

	// Է  r, g, b   . 
	cvSplit( src, r, g, b, NULL );

	// ӽ . 
	IplImage* s = cvCreateImage(cvGetSize(src), IPL_DEPTH_32F, 1); 
	cvZero(s); 

	cvAcc(b, s); 
	cvAcc(g, s); 
	cvAcc(r, s); 

	// 300 ū ȼ   300 .
	cvThreshold( s, s, 300, 300, CV_THRESH_TRUNC ); 
	cvConvertScale( s, dst, 1, 0 ); 

	cvReleaseImage( &r ); 
	cvReleaseImage( &g ); 
	cvReleaseImage( &b ); 
	cvReleaseImage( &s ); 
} 

int main(int argc, char** argv) 
{
	//  ̸  ̸  .
	cvNamedWindow( argv[1], 1 );

	//  ̸ شϴ  ҷ.
	IplImage* src = cvLoadImage( argv[1] ); 
	IplImage* dst = cvCreateImage( cvGetSize(src), src->depth, 1); 
	sum_rgb( src, dst);

	// 쿡  .
	cvShowImage( argv[1], dst );

	// "ESC" Ű   ٸ. 
	while( 1 ) { if( (cvWaitKey( 10 )&0x7f) == 27 ) break; }

	//  ޸  ڿ .
	cvDestroyWindow( argv[1] );
	cvReleaseImage( &src );
	cvReleaseImage( &dst ); 
} 
