// : ex9_avgback.exe <avi_file>
//

#include "cxcore.h"
#include "cv.h"
#include "highgui.h"
#include "conncomp.h"
#include <stdio.h>

//    
// 
// Float Ÿ, 3ä  
// 
IplImage *IavgF,*IdiffF, *IprevF, *IhiF, *IlowF;
IplImage *Iscratch,*Iscratch2; 

// Float Ÿ, 1ä  
// 
IplImage *Igray1,*Igray2, *Igray3; 
IplImage *Ilow1, *Ilow2, *Ilow3; 
IplImage *Ihi1, *Ihi2, *Ihi3; 

// Byte Ÿ, 1ä  
// 
IplImage *Imaskt = NULL; 

//  . ߿  ϱ Ͽ ȴ. 
// 
float Icount; 

// Ű  I ܼ  ũ⸦ ϱ  ޵Ǿ. 
// 
void AllocateImages( IplImage* I )
{
	CvSize sz = cvGetSize( I );

	IavgF 	= cvCreateImage( sz, IPL_DEPTH_32F, 3 ); 
	IdiffF 	= cvCreateImage( sz, IPL_DEPTH_32F, 3 ); 
	IprevF	= cvCreateImage( sz, IPL_DEPTH_32F, 3 ); 
	IhiF 	= cvCreateImage( sz, IPL_DEPTH_32F, 3 ); 
	IlowF 	= cvCreateImage( sz, IPL_DEPTH_32F, 3 ); 
	Ilow1 	= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	Ilow2 	= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	Ilow3 	= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	Ihi1 	= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	Ihi2 	= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	Ihi3 	= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	cvZero( IavgF ); 
	cvZero( IdiffF ); 
	cvZero( IprevF ); 
	cvZero( IhiF ); 
	cvZero( IlowF ); 
	Icount = 0.00001f; // 0  ʵ

	Iscratch	= cvCreateImage( sz, IPL_DEPTH_32F, 3 ); 
	Iscratch2	= cvCreateImage( sz, IPL_DEPTH_32F, 3 ); 
	Igray1		= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	Igray2 		= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	Igray3		= cvCreateImage( sz, IPL_DEPTH_32F, 1 ); 
	Imaskt 		= cvCreateImage( sz, IPL_DEPTH_8U, 1 ); 
	cvZero( Iscratch ); 
	cvZero( Iscratch2 ); 
}

// ϳ ̻  ̿Ͽ  нѴ. 
// Ű  I  н  8Ʈ 3ä ÷ ̴. 
// 
void accumulateBackground( IplImage* I )
{
	static int first = 1; 					// ! 忡  ʴ. 
	cvConvertScale( I, Iscratch, 1, 0 ); 	// float ȯ.

	if( !first )
	{
		cvAcc( Iscratch, IavgF ); 
		cvAbsDiff( Iscratch, IprevF, Iscratch2 ); 
		cvAcc( Iscratch2, IdiffF ); 
		Icount += 1.0;
	} 

	first = 0; 
	cvCopy( Iscratch, IprevF ); 
} 

void setHighThreshold( float scale ) 
{ 
	cvConvertScale( IdiffF, Iscratch, scale ); 
	cvAdd( Iscratch, IavgF, IhiF ); 
	cvSplit( IhiF, Ihi1, Ihi2, Ihi3, 0 ); 
} 

void setLowThreshold( float scale ) 
{ 
	cvConvertScale( IdiffF, Iscratch, scale ); 
	cvSub( IavgF, Iscratch, IlowF ); 
	cvSplit( IlowF, Ilow1, Ilow2, Ilow3, 0 ); 
} 

void createModelsfromStats() 
{
	//   ϱ
	cvConvertScale( IavgF, IavgF, (double)(1.0/Icount) ); 
	cvConvertScale( IdiffF, IdiffF, (double)(1.0/Icount) );

	// IdiffF   ä  0 Ǹ  ȴ. 
	// 
	cvAddS( IdiffF, cvScalar( 1.0, 1.0, 1.0 ), IdiffF ); 
	setHighThreshold( 7.0 ); 
	setLowThreshold( 6.0 ); 
}

//   : 0,255ũ, 255  ȼ ǹ 
// I - Է , 8Ʈ 3ä
// Imask -  ũ , 8Ʈ 1ä 
// 
void backgroundDiff(IplImage* I, IplImage* Imask )
{ 
	cvConvertScale( I, Iscratch, 1, 0 ); 			// Ǽ ȯ 
	cvSplit( Iscratch, Igray1, Igray2, Igray3, 0 );

	// ä 1 
	// 
	cvInRange( Igray1, Ilow1, Ihi1, Imask );

	// ä 2 
	// 
	cvInRange( Igray2, Ilow2, Ihi2, Imaskt ); 
	cvOr( Imask, Imaskt, Imask );

	// ä 3 
	// 
	cvInRange( Igray3, Ilow3, Ihi3, Imaskt ); 
	cvOr( Imask, Imaskt, Imask );

	// ,   Ŵ 
	// 
	cvSubRS( Imask, cvScalar(255), Imask ); 
} 

void deallocateImages() 
{ 
	cvReleaseImage( &IavgF ); 
	cvReleaseImage( &IdiffF ); 
	cvReleaseImage( &IprevF ); 
	cvReleaseImage( &IhiF ); 
	cvReleaseImage( &IlowF ); 
	cvReleaseImage( &Ilow1 ); 
	cvReleaseImage( &Ilow2 ); 
	cvReleaseImage( &Ilow3 ); 
	cvReleaseImage( &Ihi1 ); 
	cvReleaseImage( &Ihi2 ); 
	cvReleaseImage( &Ihi3 ); 
	cvReleaseImage( &Iscratch ); 
	cvReleaseImage( &Iscratch2 ); 
	cvReleaseImage( &Igray1 ); 
	cvReleaseImage( &Igray2 ); 
	cvReleaseImage( &Igray3 ); 
	cvReleaseImage( &Imaskt ); 
} 

int main(int argc, char** argv)
{
	int count = 0;
	int trainig_frames = 100;
	IplImage* frame;
	IplImage* mask = NULL;
	CvCapture* capture = cvCreateFileCapture( argv[1] );

	cvNamedWindow( "AvgBack", CV_WINDOW_AUTOSIZE );
	cvNamedWindow( "Mask", CV_WINDOW_AUTOSIZE );

	while(1) 
	{
		frame = cvQueryFrame( capture );
		if( !frame ) break;

		if( mask == NULL )
		{
			AllocateImages( frame );
			mask = cvCreateImage( cvGetSize(frame), IPL_DEPTH_8U, 1 );
			cvZero( mask );
		}

		if( count < trainig_frames ) 
		{
			accumulateBackground( frame );
		}
		else 
		{
			if( count == trainig_frames ) 
			{
				createModelsfromStats();
				printf("Background model is created!\n");
			}

			backgroundDiff( frame, mask );
			cvThreshold( mask, mask, 15, 255, CV_THRESH_BINARY );
		}
		count++;
		cvFlip( mask, mask );

		//     Ϸ Ʒ ּ ϶.
		//find_connected_components( mask );

		cvShowImage( "AvgBack", frame );
		cvShowImage( "Mask", mask );

		char c = cvWaitKey(33);
		if( c == 27 ) break;
	}

	deallocateImages();
	cvReleaseImage( &mask );
	cvReleaseCapture( &capture );
	cvDestroyWindow( "AvgBack" );
	cvDestroyWindow( "Mask" );

	return 0;
}

